#ifdef __Lynx__
/* for __inb, __outb etc... */
#include "<dg_free_fmt>/port_ops_lynx.h"
#else  /* __linux__ */
#include "<dg_free_fmt>/port_ops_linux.h"
#include "<dg_free_fmt>/swab-extra-linux.h"
#endif
#include "<sys_lower><drvr_type>.h"
#include "<sys_lower>UserDefined<drvr_type>.h"
#include "<sys_lower>Version<drvr_type>.h"

int sem_drvr = 1; /* initial semaphore value */

/* next are for timing measurements */
#define TSTR_LEN 32 /* time string lengths */
/* time statistic string */
char GlobTimeStatS[TSTR_LEN] = { [0 ... sizeof(GlobTimeStatS)-1] = 0 };
#ifdef __Lynx__
unsigned long GlobStartS = 0, GlobEndS = 0; /* seconds */
unsigned int  GlobStartN = 0, GlobEndN = 0; /* nanoseconds */
unsigned int  GlobCalVal = 0; /* timing measurements calibration value */
#else /* __linux__ */
static struct timespec _t_beg, _t_end, _t_delta;
static s64 _ac_etime;
#endif	/* __Lynx__ */

/* -------> <mod_name> <dg_dummy_str> version info <------- */
/* driver compilation date and time */
static char <sys_lower>_compile_date[]  = __DATE__;
static char <sys_lower>_compile_time[]  = __TIME__;

/* which driverGen version was used to generate current code */
static const char <sys_lower>_version[] = "<dg_string>";

/* generation date in hex and human representation */
static const char <sys_lower>_generation_time_str[] = "<dg_comment>";
#define <mod_name>_GENERATION_TIME_HEX <hex_num>
/* ------------------------------------------------------------------------- */

/* to suppress implisit declaration warnings */
extern int nanotime(unsigned long *);
extern int ksprintf(char *, char *, ...);
extern int unmapVmeAddr(DevInfo_t*) __attribute__ ((weak));

/**
 * @brief Current driver/simulator version.
 *
 * @param vp -- if not @e NULL - driver version string will be placed here
 *
 * If @b vp is @e NULL, then driver compilation date and @e driverGen version,
 * by which current code was generated are printed out to the terminal output.
 * If @b vp is not null, then it is set to the address with version info.
 * No terminal printout is performed in this case.
 *
 * @return current driver version number
 */
static int DisplayVersion(char **vp)
{
	static char vers_info_str[MAX_STR] =
		{ [0 ... sizeof(vers_info_str)-1] = 0 };


	if (!vers_info_str[0]) { /* not initialized yet */
		<sys_lower>_compile_date[11] = 0;
		<sys_lower>_compile_time [9] = 0;

		/* build-up version info string */
		ksprintf(vers_info_str, "Compiled on: %s %s."
			 " Generated by driverGen <%s> on [ %s ]",
			 <sys_lower>_compile_date, <sys_lower>_compile_time,
			 <sys_lower>_version, <sys_lower>_generation_time_str);
	}

	if (vp)
		*vp = vers_info_str;
	else
		kkprintf("\n<mod_name> <dg_dummy_str> <Vers. %d>\n%s",
			 <mod_name>_<fancy_str>_CURRENT_VERSION,
			 vers_info_str);

	return <mod_name>_<fancy_str>_CURRENT_VERSION;
}

#ifdef __Lynx__

/**
 * @brief Calibration for timing measurements
 *
 * @param info -- dev info table
 *
 * Find out how much time does @e timing @e measurements algorithm itself
 * takes. This time inaccuracy will be taken into account during timing
 * measurements computation. Consider it like timing collibration mechanism.
 *
 * For Linux - calibration is always zero.
 *
 * @return rough estimation for timing measurement in nanoseconds for Lynx
 * @return 0 - in case of Linux
 */
static unsigned int CalibrateTime(DevInfo_t *info)
{
	int cntr;
	unsigned int nsS, nsF, calVal; /* ns */
	unsigned long sS, sF;	         /* s */
	unsigned long long sum = 0;

	/* 100 sampling */
	for (cntr = 0; cntr < 0x64; cntr++) {
		/* hope that is less then 4s (if no - then you are fucked!) */
		nsS = nanotime(&sS);
		nsF = nanotime(&sF);
		calVal = ((sF-sS) && nsF < nsS) ? nsF + 1000000000 - nsS :
			nsF - nsS;
		sum += calVal;
	}

	calVal = sum/0x64;
	return calVal;
}

#else  /* __linux__ */

/* form kernel/lib/div64.c */
uint32_t __attribute__((weak)) __div64_32(uint64_t *n, uint32_t base)
{
	uint64_t rem = *n;
	uint64_t b = base;
	uint64_t res, d = 1;
	uint32_t high = rem >> 32;

	/* Reduce the thing a bit first */
	res = 0;
	if (high >= base) {
		high /= base;
		res = (uint64_t) high << 32;
		rem -= (uint64_t) (high*base) << 32;
	}

	while ((int64_t)b > 0 && b < rem) {
		b = b+b;
		d = d+d;
	}

	do {
		if (rem >= b) {
			rem -= b;
			res += d;
		}
		b >>= 1;
		d >>= 1;
	} while (d);

	*n = res;
	return rem;
}

#endif


/**
 * @brief Process timing data, that was measured during driver code execution.
 *
 * @param tStr   -- measured time in %E format
 *
 * As currently @e LynxOS doesn't support %E output format, time string in
 * seconds (%E) representation is build-up and store in @e tStr parameter.
 * Note, that accuracy is limited up to 4 sec MAX. So if exec time is more,
 * than buildup string will contain notification message saying, that time is
 * more then 4 secs.
 *
 * @return Computed time in ns, @b LIMITED up to 4s (i.e. 4E+9ns) If time
 *         exeeds 4s, then -1 (i.e. 0xffffffff) is returnded. @e tStr string
 *         is set to the measured time in sec (%E format), or if it exeeds 4
 *         sec, then string will contain appropriate message.
 */
static unsigned int ComputeTime(char tStr[TSTR_LEN])
{
	int tseCntr, power;
	unsigned int  execTN = 0; /* total execution time in ns */
	unsigned long execTS = 0; /* total execution time in sec */

	static int e[10] = { /* all possible exp values */
		1,	   /* s  */
		10,	   /* ms */
		100,	   /* ms */
		1000,	   /* ms */
		10000,	   /* us */
		100000,	   /* us */
		1000000,   /* us */
		10000000,  /* ns */
		100000000, /* ns */
		1000000000 /* ns */
	};

	/* finish time measurements */
#ifdef __Lynx__
	GlobEndN = nanotime(&GlobEndS);
	execTS = GlobEndS - GlobStartS; /* total exec time in seconds */
#else
	getnstimeofday(&_t_end);
	_t_delta = timespec_sub(_t_end, _t_beg);
	_ac_etime = timespec_to_ns(&_t_delta);
	execTN = __div64_32(&_ac_etime, e[9]);
	execTS = _ac_etime;
#endif

	/* exec time is more or equal 4 sec. printout and return */
	if (execTS >= 4) {
		ksprintf(tStr, "> 4.00000E+00s");
		return -1;
	}

	/* init time string */
	bzero(tStr, sizeof(tStr));

	/* printout in XXs XXns format */
	/*
	cprintf("\nDone in %ds %dns.\n",
		execTS, (execTS && GlobEndN < GlobStartN) ?
		GlobEndN + e[9] - GlobStartN : GlobEndN - GlobStartN);
	*/

	/* convert seconds to nanoseconds */
	execTS *= e[9];

#ifdef __Lynx__
	/* compute total exec time in nanosec */
	execTN = execTS + GlobEndN - GlobStartN - GlobCalVal;
#else
	execTN += execTS;
#endif

	/* get current time dimension */
	for (power = 9; power >= 0; power--)
		if (execTN/e[power])/* we've got our dimension */
			break;

	/* build-up time string tail. precision will be */
	/* limited to 5 digits after the decimal point  */
	ksprintf(tStr, "%u", execTN);
	for (tseCntr = power; tseCntr >= 1; tseCntr--)
		/* shift one position to the right */
		tStr[tseCntr+1] = tStr[tseCntr];
	tStr[1] = '.';
	tStr[7] = 'E';
	tStr[8] = (9-power) ? '-' : '+';
	ksprintf(&tStr[9], "%02ds", 9-power);
	return execTN;
}


/* Standart getting/setting register operations for <mod_name> module
   are located in included file */
#include "<sys_lower>GetSetReg.inc.c"

